unit Unit1;

interface

uses
  Windows, Messages,SysUtils,
  Variants, Classes, Graphics,
  Controls, Forms, Dialogs,
  ComCtrls, Menus, ExtCtrls,
  StdCtrls, Ucomunes, math, Grids;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    Image1: TImage;
    Button4: TButton;
    StatusBar1: TStatusBar;
    StatusBar2: TStatusBar;
    Label2: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    coord: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Button5: TButton;
    Label4: TLabel;
    ComboBox1: TComboBox;
    Label6: TLabel;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    Label7: TLabel;
    StringGrid1: TStringGrid;
    Label5: TLabel;
    Label8: TLabel;
    RadioButton6: TRadioButton;
    Label9: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Image1MouseEnter(Sender: TObject);
    procedure Image1MouseLeave(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TabSheet2Show(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
  private
    { Private declarations }
    nfb     : integer ; // num fig biblioteca
    Bib     : Biblio;
    indFC   : word;

    Escen   : Escena;
    nfe     : word;
    indFE   : word;

    fig     : CFigura;
    papel   : Tcanvas;
    NPX,NPY,
    XX,YY,
    Ang     : integer;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// create de la Forma
procedure TForm1.FormCreate(Sender: TObject);
begin
  papel := Image1.Canvas;

  NPX   := Image1.Width;
  NPY   := Image1.Height;

  coord.Hide;

  // inicializar Num FIG Escen
  nfe := 0;

  // Cambir el ancho de la columna 0 del StringGrid
  with StringGrid1 do begin
    rowCount     := 2;
    ColWidths[0] := 20;
    ColWidths[1] := 100;
    ColWidths[2] := 20;

    Cells[0,0] := 'N';
    Cells[1,0] := 'Nombre';
    Cells[2,0] := 'Vis';
  end;


end;

// Metodo abrir Archivo de figura
procedure TForm1.Button1Click(Sender: TObject);
var
  k,j    : word;
  idc,id : TextFile;
  nn     : string;
begin
  // Abrir el Archivo de control
  // asignando el nombre en disco al manejador
  AssignFile(idc,'./bib1/control.dat');
  // abrir para lectura
  reset(idc);

  readln(idc,nn);
  Memo1.Lines.Add('Biblioteca:');
  Memo1.Lines.Add(nn);

  // numero de fig en la BIB
  Memo1.Lines.Add('');
  readln(idc,nfb);

  // damos tamao al arreglo de la BIB
  SetLength(Bib,nfb);

  for j := 0 to nfb - 1 do begin
    // leer nombre de la figura
    readln(idc,nn);
    // asignando el nombre en disco al manejado
    nn := './bib1/'+nn+'.sut';
    AssignFile(id,nn);
    // abrir para lectura
    reset(id);

    // manipularlo
    readln(id,nn);
    Bib[j].nom := nn;
    Memo1.Lines.Add(nn);

    // leer puntos
    Memo1.Lines.Add('');
    readln(id,Bib[j].np);
    Memo1.Lines.Add('NP= '+IntToStr(Bib[j].np));

    Setlength(Bib[j].Apun,Bib[j].np,2);
    for k := 0 to Bib[j].np - 1 do begin
      readln(id,Bib[j].Apun[k][0], Bib[j].Apun[k][1]);
      Memo1.Lines.Add(
           FloatToStr(Bib[j].Apun[k][0])+ ' '+
           FloatToStr(Bib[j].Apun[k][1]));
    end;

    // leer trazos
    Memo1.Lines.Add('');
    readln(id,Bib[j].nt);
    Memo1.Lines.Add('NT= '+IntToStr(Bib[j].nt));

    Setlength(Bib[j].Atra,Bib[j].nt,2);
    for k := 0 to Bib[j].nt - 1 do begin
      readln(id,Bib[j].Atra[k][0], Bib[j].Atra[k][1]);
      Memo1.Lines.Add(
           IntToStr(Bib[j].Atra[k][0])+ ' '+
           IntToStr(Bib[j].Atra[k][1]));
    end;

    // leer un renglon y omitir su contenido
    readln(id);

    // PC escala
    Memo1.Lines.Add('');
      readln(id,Bib[j].PCEx , Bib[j].PCEy);
      Memo1.Lines.Add(
           FloatToStr(Bib[j].PCEx)+ ' '+
           FloatToStr(Bib[j].PCEy));

    // PC rotacion
    Memo1.Lines.Add('');
      readln(id,Bib[j].PCRx, Bib[j].PCRy);
      Memo1.Lines.Add(
           FloatToStr(Bib[j].PCRx)+ ' '+
           FloatToStr(Bib[j].PCRy));

    // cerrar archivo
    CloseFile(id);
  end;
  CloseFile(idc);
end;


// ------ del escenario

// refrescar escenario
procedure TForm1.Button4Click(Sender: TObject);
var
  p,q,k,j,ff,fc   : integer;
  XL,YL,
  PEx,PEy,
  PRx,PRy,
  Xe,Ye,
  Xr,Yr,
  Se,Co       : single;
begin
  papel.Rectangle(0,0,NPX,NPY);
  ff := 10;

  for j := 0 to nfe - 1 do begin
    fc := Escen[j].ind;
    copia (Bib[fc],fig);
    Ang := Escen[j].angR;
    XX := ceil(Escen[j].x);
    YY := ceil(Escen[j].y);

    // recorer trazos
    for k := 0 to fig.nt - 1 do begin
      p := fig.Atra[k][0];
      q := fig.Atra[k][1];

      PEx := fig.PCEx;
      PEy := fig.PCEy;

      PRx := fig.PCRx;
      PRy := fig.PCRy;

      XL := fig.Apun[p][0];
      YL := fig.Apun[p][1];

      // Punto inicial
      // escalar
      Xe := ff*(XL-PEx)+PEx - PRx;
      Ye := ff*(YL-PEy)+PEy - PRy;

      // Rotacion
      Se := sin(Pi*Ang/180);
      Co := cos(Pi*Ang/180);

      Xr := Xe*Co - Ye*Se + PRx;
      Yr := Xe*Se + Ye*Co + PRy;

      papel.MoveTo(     XX + ceil(Xr),
                   NPY-(YY + ceil(Yr)));

      XL := fig.Apun[q][0];
      YL := fig.Apun[q][1];

      // Punto final
      // escalar
      Xe := ff*(XL-PEx)+PEx - PRx;
      Ye := ff*(YL-PEy)+PEy - PRy;

      Xr := Xe*Co - Ye*Se + PRx;
      Yr := Xe*Se + Ye*Co + PRy;

      papel.LineTo(     XX + ceil(Xr),
                   NPY-(YY + ceil(Yr)));

    end;
  end;
end;

// Metodos de la Interface de pintar

// muestra el letrero de coordenada
procedure TForm1.Image1MouseEnter(Sender: TObject);
begin
  coord.Show;
end;

// esconde el letrero de coordenada
procedure TForm1.Image1MouseLeave(Sender: TObject);
begin
  coord.Hide;
end;

// actualizamos el letrero con la coordenada actual
procedure TForm1.Image1MouseMove(Sender: TObject;
  Shift : TShiftState;
  X, Y  : Integer);
begin
  coord.Caption := '('+IntToStr(X)+','
                      +IntToStr(NPY-Y)+')';

  coord.top  := Image1.Top  + Y -10;
  coord.left := Image1.Left + X +10;
end;

procedure TForm1.StringGrid1SelectCell(Sender: TObject;
  ACol, ARow: Integer;
  var CanSelect: Boolean);
var
  nom    : string;
  jj  : word;
begin
  // Seleccion del objeto
  Label8.Caption := 'Sel: ' + IntToStr(ARow);
  indFE := ARow-1;

  jj := indFE;

  // Escribir el nombre de la Figura
  StatusBar1.Panels[0].Text := Escen[jj].nom;

  // Escribir la posicion Figura
  StatusBar1.Panels[1].Text := FloatToStr( Escen[jj].x );
  StatusBar1.Panels[2].Text := FloatTostr( Escen[jj].y );

  // Escribir el angulo de rotacion Figura
  StatusBar1.Panels[3].Text := IntToStr( Escen[jj].angR);

  // Escribir las escalas
  StatusBar1.Panels[4].Text := FloatToStr( Escen[jj].ex);
  StatusBar1.Panels[5].Text := FloatToStr( Escen[jj].ey);

  // visiblidad
  StatusBar1.Panels[6].Text := LogicoToStr(Escen[jj].visib);

end;


// se oprime un boton del mouse
procedure TForm1.Image1MouseDown(Sender: TObject;
  Button : TMouseButton;
  Shift  : TShiftState;
  X, Y   : Integer);
var
  ant : integer;
begin
  if RadioButton1.Checked then begin
    // Mueve la figura seleccionada a esa coordenada
    Escen[indFe].x := X;
    Escen[indFe].y:= NPY-Y;

    Button4.Click;

    // actualiza posicin de la figuar en el StatusBar1
    StatusBar1.Panels[1].Text := IntToStr(XX);
    StatusBar1.Panels[2].Text := IntTostr(YY);
  end;

  // Inserta una figura nueva
  if RadioButton5.Checked and (indFC>=0)then begin
    // insertamos en la Escena a ala FIGURA
    inc(nfe);
    Label7.Caption := IntToStr(nfe);
    SetLength(Escen,nfe);
    ant := nfe-1;
    Escen[ant].ind := indFC;

    // pintar la figura en esa coordenada
    XX := X;
    YY := NPY-Y;
    Escen[ant].x     := XX;
    Escen[ant].y     := YY;
    Escen[ant].angR  := 0;
    Escen[ant].ex    := 1.0;
    Escen[ant].ey    := 1.0;
    Escen[ant].visib := true;
    Escen[ant].nom   := Bib[indFC].nom+'-'+IntToStr(nfe);

    StringGrid1.RowCount := nfe+1;
    StringGrid1.Cells[0,nfe] := IntToStr(nfe);
    StringGrid1.Cells[1,nfe] := Escen[ant].nom;
    StringGrid1.Cells[2,nfe] := 'S';

    Button4.Click;

    // actualiza posicin de la figuar en el StatusBar1
    StatusBar1.Panels[1].Text := IntToStr(XX);
    StatusBar1.Panels[2].Text := IntTostr(YY);
  end;

  if RadioButton2.Checked then begin
    // Rota la figura en esa coordenada y la pinta
    Ang := Escen[indFE].angR;
    Ang := Ang + StrToInt(Edit1.Text);
    if (Ang>360) then Ang := Ang - 360;
    Escen[indFE].angR := Ang;

    StatusBar1.Panels[3].Text := IntTostr(Ang);
    Button4.Click;
  end;

end;

// Se muestra la interface del ESCENARIO
procedure TForm1.TabSheet2Show(Sender: TObject);
var
  k  : integer;
begin
  ComboBox1.Items.Clear;
  for k := 0 to nfb - 1 do
    ComboBox1.Items.Add(Bib[k].nom);

  ComboBox1.ItemIndex := -1;
end;

// Se selecciona una figura
procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  indFC  := ComboBox1.ItemIndex;
  StatusBar1.Panels[0].Text := Bib[indFC].nom;
end;


    end.
